/* Generated from Extensions for telepathy-sofiasip



 */

#ifdef __cplusplus
extern "C" {
#endif

/**
 *
TpsipLocalHoldState:
 * @TPSIP_LOCAL_HOLD_STATE_UNHELD: <![CDATA[           All streams are unheld (the call is active). New channels SHOULD           have this hold state.         ]]>
 * @TPSIP_LOCAL_HOLD_STATE_HELD: <![CDATA[           All streams are held (the call is on hold)         ]]>
 * @TPSIP_LOCAL_HOLD_STATE_PENDING_HOLD: <![CDATA[           The connection manager is attempting to move to state Held, but           has not yet completed that operation. It is unspecified whether           any, all or none of the streams making up the channel are on hold.         ]]>
 * @TPSIP_LOCAL_HOLD_STATE_PENDING_UNHOLD: <![CDATA[           The connection manager is attempting to move to state Held, but           has not yet completed that operation. It is unspecified whether           any, all or none of the streams making up the channel are on hold.         ]]>
 *
 * <![CDATA[         The hold state of a channel.       ]]>
 *
 * Bitfield/set of flags generated from the Telepathy specification.
 */
typedef enum {
    TPSIP_LOCAL_HOLD_STATE_UNHELD = 0,
    TPSIP_LOCAL_HOLD_STATE_HELD = 1,
    TPSIP_LOCAL_HOLD_STATE_PENDING_HOLD = 2,
    TPSIP_LOCAL_HOLD_STATE_PENDING_UNHOLD = 3,
} TpsipLocalHoldState;

/**
 * NUM_TPSIP_LOCAL_HOLD_STATES:
 *
 * 1 higher than the highest valid value of #TpsipLocalHoldState.
 */
#define NUM_TPSIP_LOCAL_HOLD_STATES (3+1)

/**
 *
TpsipLocalHoldStateReason:
 * @TPSIP_LOCAL_HOLD_STATE_REASON_NONE: <![CDATA[           The reason cannot be described by any of the predefined values           (connection managers SHOULD avoid this reason, but clients MUST           handle it gracefully)         ]]>
 * @TPSIP_LOCAL_HOLD_STATE_REASON_REQUESTED: <![CDATA[           The change is in response to a user request         ]]>
 * @TPSIP_LOCAL_HOLD_STATE_REASON_RESOURCE_NOT_AVAILABLE: <![CDATA[           The change is because some resource was not available         ]]>
 *
 * <![CDATA[         The reason for a change to the Local_Hold_State. Clients MUST         treat unknown values as equivalent to Local_Hold_State_Reason_None.       ]]>
 *
 * Bitfield/set of flags generated from the Telepathy specification.
 */
typedef enum {
    TPSIP_LOCAL_HOLD_STATE_REASON_NONE = 0,
    TPSIP_LOCAL_HOLD_STATE_REASON_REQUESTED = 1,
    TPSIP_LOCAL_HOLD_STATE_REASON_RESOURCE_NOT_AVAILABLE = 2,
} TpsipLocalHoldStateReason;

/**
 * NUM_TPSIP_LOCAL_HOLD_STATE_REASONS:
 *
 * 1 higher than the highest valid value of #TpsipLocalHoldStateReason.
 */
#define NUM_TPSIP_LOCAL_HOLD_STATE_REASONS (2+1)


#ifdef __cplusplus
}
#endif
