#include <glib-object.h>
#include <dbus/dbus-glib.h>
#include <telepathy-glib/dbus-properties-mixin.h>

G_BEGIN_DECLS

/**
 * TpsipSvcChannelInterfaceHold:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _TpsipSvcChannelInterfaceHold TpsipSvcChannelInterfaceHold;

/**
 * TpsipSvcChannelInterfaceHoldClass:
 *
 * The class of TpsipSvcChannelInterfaceHold.
 */
typedef struct _TpsipSvcChannelInterfaceHoldClass TpsipSvcChannelInterfaceHoldClass;

GType tpsip_svc_channel_interface_hold_get_type (void);
#define TPSIP_TYPE_SVC_CHANNEL_INTERFACE_HOLD \
  (tpsip_svc_channel_interface_hold_get_type ())
#define TPSIP_SVC_CHANNEL_INTERFACE_HOLD(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), TPSIP_TYPE_SVC_CHANNEL_INTERFACE_HOLD, TpsipSvcChannelInterfaceHold))
#define TPSIP_IS_SVC_CHANNEL_INTERFACE_HOLD(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), TPSIP_TYPE_SVC_CHANNEL_INTERFACE_HOLD))
#define TPSIP_SVC_CHANNEL_INTERFACE_HOLD_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), TPSIP_TYPE_SVC_CHANNEL_INTERFACE_HOLD, TpsipSvcChannelInterfaceHoldClass))


typedef void (*tpsip_svc_channel_interface_hold_get_hold_state_impl) (TpsipSvcChannelInterfaceHold *self,
    DBusGMethodInvocation *context);
void tpsip_svc_channel_interface_hold_implement_get_hold_state (TpsipSvcChannelInterfaceHoldClass *klass, tpsip_svc_channel_interface_hold_get_hold_state_impl impl);
/**
 * tpsip_svc_channel_interface_hold_return_from_get_hold_state:
 * @context: The D-Bus method invocation context
 * @out_HoldState: guint  (FIXME, generate documentation)
 * @out_Reason: guint  (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void tpsip_svc_channel_interface_hold_return_from_get_hold_state (DBusGMethodInvocation *context,
    guint out_HoldState,
    guint out_Reason);
static inline void
tpsip_svc_channel_interface_hold_return_from_get_hold_state (DBusGMethodInvocation *context,
    guint out_HoldState,
    guint out_Reason)
{
  dbus_g_method_return (context,
      out_HoldState,
      out_Reason);
}

typedef void (*tpsip_svc_channel_interface_hold_request_hold_impl) (TpsipSvcChannelInterfaceHold *self,
    gboolean in_Hold,
    DBusGMethodInvocation *context);
void tpsip_svc_channel_interface_hold_implement_request_hold (TpsipSvcChannelInterfaceHoldClass *klass, tpsip_svc_channel_interface_hold_request_hold_impl impl);
/**
 * tpsip_svc_channel_interface_hold_return_from_request_hold:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void tpsip_svc_channel_interface_hold_return_from_request_hold (DBusGMethodInvocation *context);
static inline void
tpsip_svc_channel_interface_hold_return_from_request_hold (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void tpsip_svc_channel_interface_hold_emit_hold_state_changed (gpointer instance,
    guint arg_HoldState,
    guint arg_Reason);


G_END_DECLS
